/*

  $Id: ISODB.h 530 2016-08-12 17:35:32Z john $

*/

#ifndef __ISODal_ISODB_h__
#define __ISODal_ISODB_h__

#include <ISODal/ISODal.h>
#include <librfcdal/SqlSchema.h>
#include <librfcdal/DalDatabase.h>

#include <Base4c/Mutex.h>

namespace ISODal
{
	class ISODal_Export ISODB
	{
		private:
			RfcDal::DalDatabase* _pdb;
			int _nUsageCount;
			Base4c::Mutex _mx;

		public:
			ISODB( RfcDal::DalDatabase* pdb = NULL );
			ISODB( const ISODB& db );
			virtual ~ISODB();

			ISODB& operator=( const ISODB& db );

			bool inUse() const;

		protected:
			void ucInc();
			void ucDec();

			friend class Connection;
	};

	typedef std::vector<ISODB> ISODBList;

	class ISODal_Export Connection
	{
		private:
			ISODB* _pdb;

		public:
			Connection( ISODB* pdb );
			Connection( const Connection& connection );
			virtual ~Connection();

			Connection& operator=( Connection& connection );

			RfcDal::DalDatabase& db();
			operator RfcDal::DalDatabase&();
	};

	const ISODal_Export RfcDal::SqlSchema& schema();
	ISODal_Export Connection connection() throw( RfcDal::DalDatabaseException );
	void ISODal_Export connect( const std::string& strConnect ) throw( RfcDal::DalDatabaseException );
	void ISODal_Export disconnect();
	const ISODal_Export RfcDal::DalDatabase::ConnectionParameterMap& connectionParameters();
};

#endif /* !__ISODal_ISODB_h__ */
