#ifndef __ISOData_Updateable_h__
#define __ISOData_Updateable_h__

#include <ISOData/ISOData.h>

#include <ISOData/Base.h>
#include <ISOData/Exception.h>

#include <Auth4cData/User.h>
#include <Base4c/Timestamp.h>
#include <librfcdal/DalDatabase.h>

namespace ISOData
{
	class ISOData_Export Updateable : public Base
	{
		private:
			Base4c::Timestamp _tsCreatedWhen;
			Auth4cData::User _userCreatedBy;
			Base4c::Timestamp _tsUpdatedWhen;
			Auth4cData::User _userUpdatedBy;

		public:
			Updateable();
			Updateable( const Base4c::Timestamp& tsCreatedWhen,
						const Auth4cData::User& userCreatedBy,
						const Base4c::Timestamp& tsUpdatedWhen,
						const Auth4cData::User& userUpdatedBy );
			Updateable( const Updateable& updateable );
			virtual ~Updateable();

			Updateable& operator=( const Updateable& updateable );

			const Base4c::Timestamp& createdWhen() const;
			const Auth4cData::User& createdBy() const;
			const Base4c::Timestamp& updatedWhen() const;
			const Auth4cData::User& updatedBy() const;

			static Updateable fromRow( const RfcDal::DalDatabase::Row& row ) throw( ISOData::Exception );
			virtual void update() throw( ISOData::Exception );
	};
}

#endif /* !__ISOData_Updateable_h__ */
