#ifndef __ISOImport_Import_h__
#define __ISOImport_Import_h__

#include <ISOImport/ISOImport.h>

#include <ISOImport/ImportProgress.h>

#include <ISOImport/ImportException.h>

namespace ISOImport
{
	class ISOImport_Export Import
	{
		public:
			static int importISOLanguage( const std::string& strSource, ImportProgress& progress = ImportProgress::noProgress ) throw( ISOImport::CompoundException, ISOImport::ImportException );
			static int importISOCountry( const std::string& strSource, ImportProgress& progress = ImportProgress::noProgress ) throw( ISOImport::CompoundException, ISOImport::ImportException );
			static int importISOCountryName( const std::string& strSource, ImportProgress& progress = ImportProgress::noProgress ) throw( ISOImport::CompoundException, ISOImport::ImportException );
			static int importISOCountryLanguage( const std::string& strSource, ImportProgress& progress = ImportProgress::noProgress ) throw( ISOImport::CompoundException, ISOImport::ImportException );
			static int importISOSubdivisionCategory( const std::string& strSource, ImportProgress& progress = ImportProgress::noProgress ) throw( ISOImport::CompoundException, ISOImport::ImportException );
			static int importISOSubdivisionCategoryName( const std::string& strSource, ImportProgress& progress = ImportProgress::noProgress ) throw( ISOImport::CompoundException, ISOImport::ImportException );
			static int importISOSubdivision( const std::string& strSource, ImportProgress& progress = ImportProgress::noProgress ) throw( ISOImport::CompoundException, ISOImport::ImportException );
			static int importISOSubdivisionName( const std::string& strSource, ImportProgress& progress = ImportProgress::noProgress ) throw( ISOImport::CompoundException, ISOImport::ImportException );
			static int importISOTerritory( const std::string& strSource, ImportProgress& progress = ImportProgress::noProgress ) throw( ISOImport::CompoundException, ISOImport::ImportException );
			static int importISOTerritoryName( const std::string& strSource, ImportProgress& progress = ImportProgress::noProgress ) throw( ISOImport::CompoundException, ISOImport::ImportException );
	};
}

#endif /* !__ISOImport_Import_h__ */
