/*
 * $Id: ISOExceptionDialog.h 546 2016-08-17 20:14:08Z john $
 *
 */

#ifndef __ISOUIComponents_ISOExceptionDialog_h__
#define __ISOUIComponents_ISOExceptionDialog_h__

#include <ISOUIComponents/isouicomponents_global.h>

#include <ISOImport/ImportException.h>

#include <QDialog>

class QListWidgetItem;

namespace Ui
{
	class ISOExceptionDialog;
}

namespace ISOUIComponents
{
	class ISOUIComponents_Export ISOExceptionDialog : public QDialog
	{
		Q_OBJECT

		private:
			Ui::ISOExceptionDialog* ui;
			bool _bExpanded;
			const ISOData::Exception* _peD;
			const ISOImport::ImportException* _peI;

		public:
			ISOExceptionDialog( QWidget* pparent, const ISOData::Exception& e );
			ISOExceptionDialog( QWidget* pparent, const ISOData::CompoundException& e );
			ISOExceptionDialog( QWidget* pparent, const ISOImport::ImportException& e );
			ISOExceptionDialog( QWidget* pparent, const ISOImport::CompoundException& e );
			virtual ~ISOExceptionDialog();

		private:
			void setup();

		protected slots:
			void accept();
			void copy();
			void help();
			void onDblClickException( QListWidgetItem* pitem );
	};
}

#endif /* !__ISOUIComponents_ISOExceptionDialog_h__ */
